package com.company;

import javax.management.Attribute;
import java.io.*;
import java.net.Socket;
import java.nio.charset.StandardCharsets;
import java.util.List;
import java.util.Scanner;

public class Client extends Thread {
    private Socket socket;
    private ObjectInputStream inputStream;
    private ObjectOutputStream outputStream;
    // Список всех подключенных слиентов
    private List<Client> clientList;

    public static int READ_BUFFER_SIZE = 1024;

    public Client(Socket socket, List<Client> clientList) throws IOException {
        this.socket = socket;
        this.clientList = clientList;

        inputStream = new ObjectInputStream(socket.getInputStream());
        outputStream = new ObjectOutputStream(socket.getOutputStream());
    }

    @Override
    public void run() {
       while (!isInterrupted()) {

           try {
               Transport t = (Transport) inputStream.readObject();

               for (Client client : clientList) {
                   if (client.socket != this.socket) {
                       client.outputStream.writeObject(t);
                       client.outputStream.flush();
                   }
               }

               System.out.print("\033[1;31m\033[40m " + t.Name + ": \u001B[0m ");
               System.out.println(t.Message);

           } catch (IOException exception) {
               System.out.println(exception.getMessage());
               clientList.remove(this);
               break;
           } catch (ClassNotFoundException exception) {
               System.out.print("Не смог прочитать данные клиента " + socket.getRemoteSocketAddress().toString() + ": ");
               System.out.println(exception.getMessage());
               clientList.remove(this);
               break;
           }
       }
    }
}
